Index: src/sas/sasgui/perspectives/calculator/gen_scatter_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/gen_scatter_panel.py	(revision a1b8fee73528559155793dd74cda07d0c32e9d72)
+++ src/sas/sasgui/perspectives/calculator/gen_scatter_panel.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -113,5 +113,5 @@
     def compute(self):
         """
-        excuting computation
+        executing computation
         """
         #elapsed = time.time() - self.starttime
Index: src/sas/sasgui/perspectives/calculator/resolcal_thread.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/resolcal_thread.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/resolcal_thread.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -44,5 +44,5 @@
     def compute(self):
         """
-        excuting computation
+        executing computation
         """
         self.image = map(self.func, self.qx, self.qy,
Index: src/sas/sasgui/perspectives/fitting/fitproblem.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitproblem.py	(revision 251ef68424c8f373dfb82af3c159086491c5f975)
+++ src/sas/sasgui/perspectives/fitting/fitproblem.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -1,5 +1,5 @@
 """
 Inferface containing information to store data, model, range of data, etc...
-and retreive this information. This is an inferface
+and retrieve this information. This is an inferface
 for a fitProblem i.e relationship between data and model.
 """
@@ -56,5 +56,5 @@
         """
         :param flag: bool.When flag is 1 get the computer smear value. When
-            flag is 0 ingore smear value.
+            flag is 0 ignore smear value.
         """
         self.smearer_enable = flag
@@ -305,5 +305,5 @@
         """
         :param flag: bool.When flag is 1 get the computer smear value. When
-            flag is 0 ingore smear value.
+            flag is 0 ignore smear value.
         """
         self._smear_on = flag
Index: src/sas/sasgui/perspectives/fitting/fitting.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting.py	(revision 9706d88b71e719f590147b9914149630bce2f1d2)
+++ src/sas/sasgui/perspectives/fitting/fitting.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -763,5 +763,5 @@
         the current page and set value.
         :param value: integer 0 or 1
-        :param uid: the id related to a page contaning fitting information
+        :param uid: the id related to a page containing fitting information
         """
         if uid in self.page_finder.keys():
@@ -778,8 +778,8 @@
         Used by simfitpage.py to reset a parameter given the string constrainst.
 
-        :param modelname: the name ot the model for with the parameter
+        :param modelname: the name of the model for with the parameter
                             has to reset
         :param value: can be a string in this case.
-        :param names: the paramter name
+        :param names: the parameter name
         """
         sim_page_id = self.sim_page.uid
@@ -797,5 +797,5 @@
         name into model name and parameter name example: ::
 
-            paramaterset (item) = M1.A
+            parameterset (item) = M1.A
             Will return model_name = M1 , parameter name = A
 
@@ -1117,5 +1117,5 @@
     def store_data(self, uid, data_list=None, caption=None):
         """
-        Recieve a list of data and store them ans well as a caption of
+        Receive a list of data and store them ans well as a caption of
         the fit page where they come from.
         :param uid: if related to a fit page
@@ -1196,5 +1196,5 @@
         for a given interactor.
 
-        :param event: contains type of slicer , paramaters for updating
+        :param event: contains type of slicer , parameters for updating
             the panel and panel_name to find the slicer 's panel concerned.
         """
Index: src/sas/sasgui/perspectives/fitting/fitting_widgets.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting_widgets.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/fitting/fitting_widgets.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -64,5 +64,5 @@
         selection_sizer.Add(self.data_2d_selected, (iy, ix),
                            (1, 1), wx.LEFT | wx.EXPAND | wx.ADJUST_MINSIZE, 15)
-        #contruction the sizer contaning button
+        #contruction the sizer containing button
         button_sizer.Add((20, 20), 1, wx.EXPAND | wx.ADJUST_MINSIZE, 0)
         button_sizer.Add(button_cancel, 0,
Index: src/sas/sasgui/perspectives/fitting/gpu_options.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/gpu_options.py	(revision 3bd677bda9477bbd07235d9fba448f09ae1b3932)
+++ src/sas/sasgui/perspectives/fitting/gpu_options.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -88,5 +88,5 @@
         self.option_button = {}
         self.buttons = []
-        #Check if SAS_OPENCL is already set as enviromental variable
+        #Check if SAS_OPENCL is already set as environment variable
         self.sas_opencl = os.environ.get("SAS_OPENCL", "")
 
Index: src/sas/sasgui/perspectives/fitting/simfitpage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/simfitpage.py	(revision 0a3c740de7a24dad98e912cdeee179e382e3839a)
+++ src/sas/sasgui/perspectives/fitting/simfitpage.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -976,5 +976,5 @@
         param_cbox = self.constraints_list[-1].param_cbox
         param_cbox.Clear()
-        # insert only fittable paramaters
+        # insert only fittable parameters
         for param in param_list:
             param_cbox.Append(str(param), model)
Index: src/sas/sasgui/perspectives/invariant/invariant_details.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_details.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/invariant/invariant_details.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -422,5 +422,5 @@
         except:
             scale = RECTANGLE_SCALE
-            self.warning_msg += "Recieve an invalid scale for %s\n"
+            self.warning_msg += "Receive an invalid scale for %s\n"
             self.warning_msg += "check this value : %s\n" % str(percentage)
         return  scale
Index: src/sas/sasgui/perspectives/pr/explore_dialog.py
===================================================================
--- src/sas/sasgui/perspectives/pr/explore_dialog.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/pr/explore_dialog.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
@@ -93,5 +93,5 @@
 
         :TODO: Would be nice to add printing and log/linear scales.
-            The current verison of plottools no longer plays well with
+            The current version of plottools no longer plays well with
             plots outside of guiframe. Guiframe team needs to fix this.
         """