Index: src/sans/guiframe/local_perspectives/plotting/Plotter1D.py
===================================================================
--- src/sans/guiframe/local_perspectives/plotting/Plotter1D.py	(revision cafa75f43af970e0c66f37733b6aaf7dd2e1b5ff)
+++ src/sans/guiframe/local_perspectives/plotting/Plotter1D.py	(revision 98816c431080a7aa3195b86a86597ff12a89fa15)
@@ -417,6 +417,6 @@
 
     def remove_data_by_id(self, id):
-        """'
-        remove data from plot
+        """
+            Remove data from plot
         """
         if id in self.plots.keys():
@@ -430,18 +430,5 @@
             if id in theory_list.keys():
                 data = theory_list[id]
-            # Update Graph menu and help string        
-            #h_id = self.parent._window_menu.FindItem(self.window_caption)
-            if data != None:
-                if data.__class__.__name__ == 'list':
-                    label = data[0].label
-                else:
-                    label = data.label
-            else:
-                label = '???'
-            #helpString = self.parent._window_menu.GetHelpString(h_id) 
-            d_string = (' ' + str(label) +';')
-            #new_tip = helpString.replace(d_string, '')
-            #self.parent._window_menu.SetHelpString(h_id, new_tip)  
-
+                
             del self.plots[id]
             self.graph.render(self)
@@ -450,5 +437,4 @@
                 #onRemove: graph is empty must be the panel must be destroyed
                 self.parent.delete_panel(self.uid)
-            
         
     def plot_data(self, data):
@@ -480,5 +466,4 @@
                 self._onEVT_FUNC_PROPERTY()
             except Exception, exc:
-                msg=" Encountered singular points..."
                 wx.PostEvent(self.parent, StatusEvent(status=\
                     "Plotting Error: %s"% str(exc), info="error"))
@@ -498,16 +483,9 @@
                     self.canvas._onDrawIdle()
             except Exception,exc:
-                msg=" Encountered singular points..."
                 wx.PostEvent(self.parent, StatusEvent(status=\
                     "Plotting Error: %s"% str(exc), info="error"))
             self.toolbar.update()
             self.is_zoomed = False
-            # Update Graph menu and help string        
-            #pos = self.parent._window_menu.FindItem(self.window_caption)
-            helpString = 'Show/Hide Graph: '
-            for plot in  self.plots.itervalues():
-                helpString += (' ' + str(plot.label) +';')
-            #self.parent._window_menu.SetHelpString(pos, helpString)  
-                
+            
     def draw_plot(self):
         """
@@ -850,15 +828,6 @@
                         self.get_symbol_label()[info[2]] 
             self.appearance_selected_plot.label = str(info[3])
-
-            #pos = self.parent._window_menu.FindItem(self.window_caption)
-            #helpString = 'Show/Hide Graph: '
-            #for plot in  self.plots.itervalues():
-            #    helpString += (' ' + str(plot.label) + ';')
-            #    self.parent._window_menu.SetHelpString(pos, helpString)
-            #    self._is_changed_legend_label = True
-                
         self.appD.Destroy()
         self._check_zoom_plot()
-
 
     def modifyGraphAppearance(self, event):
@@ -878,5 +847,4 @@
                                   self.is_xtick, self.is_ytick)
         self.graphApp.Bind(wx.EVT_CLOSE, self.on_graphApp_close)
-    
 
     def on_graphApp_close(self, event):
Index: src/sans/guiframe/local_perspectives/plotting/Plotter2D.py
===================================================================
--- src/sans/guiframe/local_perspectives/plotting/Plotter2D.py	(revision cafa75f43af970e0c66f37733b6aaf7dd2e1b5ff)
+++ src/sans/guiframe/local_perspectives/plotting/Plotter2D.py	(revision 98816c431080a7aa3195b86a86597ff12a89fa15)
@@ -241,9 +241,4 @@
                                    color=self.title_color)
             self.subplot.figure.canvas.draw_idle()    
-        # Update Graph menu and help string        
-        #pos = self.parent._window_menu.FindItem(self.window_caption)
-        helpString = 'Show/Hide Graph: '
-        helpString += (' ' + str(data.label) +';')
-        #self.parent._window_menu.SetHelpString(pos, helpString)
         ## store default value of zmin and zmax 
         self.default_zmin_ctl = self.zmin_2D
@@ -458,12 +453,4 @@
         dial.Destroy()
         
-        # Update Graph menu and help string 
-        if self.title_label != None:     
-            #pos = self.parent._window_menu.FindItem(self.window_caption)
-            helpString = 'Show/Hide Graph: '
-            helpString += (' ' + str(self.title_label) +';')
-            #self.parent._window_menu.SetHelpString(pos, helpString)
-
-        
     def _onEditDetector(self, event):
         """