Index: src/sas/sasgui/guiframe/gui_manager.py
===================================================================
--- src/sas/sasgui/guiframe/gui_manager.py	(revision 64ca561b6b264f63b4d7d09a6582f1f3330ae720)
+++ src/sas/sasgui/guiframe/gui_manager.py	(revision 49165488dcf1dbf657666bc78e3d4b4904d1c094)
@@ -2122,5 +2122,5 @@
         """
         if custom_config is not None:
-            sas_opencl = os.environ.get("SAS_OPENCL",None)
+            sas_opencl = os.environ.get("SAS_OPENCL")
             new_config_lines = []
             config_file = open(custom_config.__file__)
Index: src/sas/sasgui/guiframe/local_perspectives/data_loader/data_loader.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/data_loader/data_loader.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/guiframe/local_perspectives/data_loader/data_loader.py	(revision c1d5aeab1ee75d2bf50cd73195f34c011918657d)
@@ -92,5 +92,5 @@
         if dlg.ShowModal() == wx.ID_OK:
             file_list = dlg.GetPaths()
-            if len(file_list) >= 0 and not file_list[0] is None:
+            if len(file_list) >= 0 and file_list[0] is not None:
                 self._default_save_location = os.path.dirname(file_list[0])
                 path = self._default_save_location
Index: src/sas/sasgui/guiframe/media/data_formats_help.rst
===================================================================
--- src/sas/sasgui/guiframe/media/data_formats_help.rst	(revision 98c44f371117c50474cf421ea0e45b19c0d87d9e)
+++ src/sas/sasgui/guiframe/media/data_formats_help.rst	(revision 76c44696598f3a67738b403fd2fe611bd0e62075)
@@ -86,5 +86,5 @@
 
 - Spin echo length (z, in Angstroms)
-- depolarization (:math:`log(P/P_0)/(lambda^2 * thickness)`, in Angstrom^-1 cm^-1)
+- depolarization (:math:`log(P/P_0)/(lambda^2 * thickness)`, in Angstrom :sup:`-1` cm :sup:`-1`\ )
 - depolarization error in the same unit) (measurement error)
 - Spin echo length error (:math:`\Delta`\ z, in Angstroms) (experimental resolution)
Index: src/sas/sasgui/perspectives/calculator/image_viewer.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/image_viewer.py	(revision 25b9707a6650b214d61ed53e8bbc3e8f6d20d131)
+++ src/sas/sasgui/perspectives/calculator/image_viewer.py	(revision c1d5aeab1ee75d2bf50cd73195f34c011918657d)
@@ -42,13 +42,13 @@
         """
         parent = self.parent
-        if parent == None:
+        if parent is None:
             location = os.getcwd()
         else:
             location = parent._default_save_location
         path_list = self.choose_data_file(location=location)
-        if path_list == None:
+        if path_list is None:
             return
-        if len(path_list) >= 0 and not(path_list[0]is None):
-            if parent != None:
+        if len(path_list) >= 0 and path_list[0] is not None:
+            if parent is not None:
                 parent._default_save_location = os.path.dirname(path_list[0])
         err_msg = ''
Index: src/sas/sasgui/perspectives/pr/explore_dialog.py
===================================================================
--- src/sas/sasgui/perspectives/pr/explore_dialog.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/perspectives/pr/explore_dialog.py	(revision f3bf622b821c651bb6e946100b07e15cd59331fe)
@@ -269,5 +269,5 @@
         # Note: by design, the output type should always be part of the
         #       results object.
-        if self.results.outputs.has_key(output_type):
+        if output_type in self.results.outputs:
             self.plotpanel.plot.x = self.results.d_max
             self.plotpanel.plot.y = self.results.outputs[output_type][2]
Index: src/sas/sasgui/perspectives/pr/inversion_panel.py
===================================================================
--- src/sas/sasgui/perspectives/pr/inversion_panel.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/perspectives/pr/inversion_panel.py	(revision c1d5aeab1ee75d2bf50cd73195f34c011918657d)
@@ -940,5 +940,5 @@
         Choose a new input file for I(q)
         """
-        if not self._manager is None:
+        if self._manager is not None:
             self.plot_data.SetValue(str(data.name))
             try:
Index: src/sas/sasgui/perspectives/pr/pr.py
===================================================================
--- src/sas/sasgui/perspectives/pr/pr.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/perspectives/pr/pr.py	(revision c1d5aeab1ee75d2bf50cd73195f34c011918657d)
@@ -329,5 +329,5 @@
 
         # If we have a group ID, use it
-        if pr.info.has_key("plot_group_id"):
+        if 'plot_group_id' in pr.info:
             new_plot.group_id = pr.info["plot_group_id"]
         new_plot.id = IQ_FIT_LABEL
@@ -348,5 +348,5 @@
                 except:
                     err[i] = 1.0
-                    print "Error getting error", value, x[i]
+                    print("Error getting error", value, x[i])
 
             new_plot = Data1D(x, y)
@@ -356,5 +356,5 @@
             new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
             # If we have a group ID, use it
-            if pr.info.has_key("plot_group_id"):
+            if 'plot_group_id' in pr.info:
                 new_plot.group_id = pr.info["plot_group_id"]
             new_plot.id = IQ_SMEARED_LABEL
@@ -1047,5 +1047,5 @@
         try:
             pr = self._create_file_pr(data)
-            if not pr is None:
+            if pr is not None:
                 self.pr = pr
                 self.perform_estimate()
Index: src/sas/sasgui/plottools/LineModel.py
===================================================================
--- src/sas/sasgui/plottools/LineModel.py	(revision dd5bf63093de43c42cbb5ac17751c02bdd615eae)
+++ src/sas/sasgui/plottools/LineModel.py	(revision ec8886e8a26917ac9ba746be4627cefdfccbaf93)
@@ -8,5 +8,6 @@
 function should disappear in a future iteration (see notes in fitDialog)
 
-                -PDB   July 10, 2016
+PDB   July 10, 2016
+
 """
 
@@ -70,5 +71,5 @@
         runXY is when the if statement is true. I however cannot see what that
         function is for.  It needs to be documented here or removed.
-        -PDB 7/10/16 
+        PDB 7/10/16 
 
         :param x: simple value
@@ -92,5 +93,5 @@
         but the only difference between this and run is when the if 
         statement is true. I however cannot see what that function
-        is for.  It needs to be documented here or removed. -PDB 7/10/16 
+        is for.  It needs to be documented here or removed. PDB 7/10/16 
 
         :param x: simple value
Index: src/sas/sasgui/plottools/PlotPanel.py
===================================================================
--- src/sas/sasgui/plottools/PlotPanel.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/plottools/PlotPanel.py	(revision c1d5aeab1ee75d2bf50cd73195f34c011918657d)
@@ -1403,11 +1403,11 @@
         if self.scale == 'log_{10}':
             self.scale = 'linear'
-            if not self.zmin_2D is None:
+            if self.zmin_2D is not None:
                 zmin_2D_temp = math.pow(10, self.zmin_2D)
-            if not self.zmax_2D is None:
+            if self.zmax_2D is not None:
                 zmax_2D_temp = math.pow(10, self.zmax_2D)
         else:
             self.scale = 'log_{10}'
-            if not self.zmin_2D is None:
+            if self.zmin_2D is not None:
                 # min log value: no log(negative)
                 if self.zmin_2D <= 0:
@@ -1415,5 +1415,5 @@
                 else:
                     zmin_2D_temp = math.log10(self.zmin_2D)
-            if not self.zmax_2D is None:
+            if self.zmax_2D is not None:
                 zmax_2D_temp = math.log10(self.zmax_2D)
 